// Generated by CoffeeScript 1.6.2
var FOCUS_ELEMENTS, HTML, elementType, setAttribute, setFocus, _i, _len, _ref;

HTML = require("jsdom").dom.level3.html;

FOCUS_ELEMENTS = ["INPUT", "SELECT", "TEXTAREA", "BUTTON", "ANCHOR"];

HTML.HTMLDocument.prototype.__defineGetter__("activeElement", function() {
  return this._inFocus || this.body;
});

setFocus = function(document, element) {
  var inFocus, onblur, onfocus;

  inFocus = document._inFocus;
  if (element !== inFocus) {
    if (inFocus) {
      onblur = document.createEvent("HTMLEvents");
      onblur.initEvent("blur", false, false);
      inFocus.dispatchEvent(onblur);
    }
    if (element) {
      onfocus = document.createEvent("HTMLEvents");
      onfocus.initEvent("focus", false, false);
      element.dispatchEvent(onfocus);
      document._inFocus = element;
      return document.window.browser.emit("focus", element);
    }
  }
};

HTML.HTMLElement.prototype.focus = function() {};

HTML.HTMLElement.prototype.blur = function() {};

_ref = [HTML.HTMLInputElement, HTML.HTMLSelectElement, HTML.HTMLTextAreaElement, HTML.HTMLButtonElement, HTML.HTMLAnchorElement];
for (_i = 0, _len = _ref.length; _i < _len; _i++) {
  elementType = _ref[_i];
  elementType.prototype.focus = function() {
    return setFocus(this.ownerDocument, this);
  };
  elementType.prototype.blur = function() {
    return setFocus(this.ownerDocument, null);
  };
}

setAttribute = HTML.HTMLElement.prototype.setAttribute;

HTML.HTMLElement.prototype.setAttribute = function(name, value) {
  var document;

  setAttribute.call(this, name, value);
  if (name === "autofocus") {
    document = this.ownerDocument;
    if (~FOCUS_ELEMENTS.indexOf(this.tagName) && !document._inFocus) {
      return this.focus();
    }
  }
};
